
module RL02_System (
	altpll_0_areset_export,
	altpll_0_locked_export,
	clk_clk,
	clk_65_6_clk,
	clk_sdram_clk,
	d1_reset_reset_n,
	d2_reset_reset_n,
	dpr_clockbridge_in_clk,
	dpr_s2_address,
	dpr_s2_chipselect,
	dpr_s2_clken,
	dpr_s2_write,
	dpr_s2_readdata,
	dpr_s2_writedata,
	dpr_s2_byteenable,
	pio_0_in_port,
	pio_0_out_port,
	pio_1_in_port,
	pio_1_out_port,
	spi_master_cs,
	spi_master_sclk,
	spi_master_mosi,
	spi_master_miso,
	uart_0_rxd,
	uart_0_txd,
	uart_1_rxd,
	uart_1_txd,
	wire_sdram_addr,
	wire_sdram_ba,
	wire_sdram_cas_n,
	wire_sdram_cke,
	wire_sdram_cs_n,
	wire_sdram_dq,
	wire_sdram_dqm,
	wire_sdram_ras_n,
	wire_sdram_we_n);	

	input		altpll_0_areset_export;
	output		altpll_0_locked_export;
	input		clk_clk;
	input		clk_65_6_clk;
	output		clk_sdram_clk;
	input		d1_reset_reset_n;
	input		d2_reset_reset_n;
	input		dpr_clockbridge_in_clk;
	input	[12:0]	dpr_s2_address;
	input		dpr_s2_chipselect;
	input		dpr_s2_clken;
	input		dpr_s2_write;
	output	[15:0]	dpr_s2_readdata;
	input	[15:0]	dpr_s2_writedata;
	input	[1:0]	dpr_s2_byteenable;
	input	[15:0]	pio_0_in_port;
	output	[15:0]	pio_0_out_port;
	input	[23:0]	pio_1_in_port;
	output	[23:0]	pio_1_out_port;
	output		spi_master_cs;
	output		spi_master_sclk;
	output		spi_master_mosi;
	input		spi_master_miso;
	input		uart_0_rxd;
	output		uart_0_txd;
	input		uart_1_rxd;
	output		uart_1_txd;
	output	[12:0]	wire_sdram_addr;
	output	[1:0]	wire_sdram_ba;
	output		wire_sdram_cas_n;
	output		wire_sdram_cke;
	output		wire_sdram_cs_n;
	inout	[15:0]	wire_sdram_dq;
	output	[1:0]	wire_sdram_dqm;
	output		wire_sdram_ras_n;
	output		wire_sdram_we_n;
endmodule
